(function($){
  $.fn.getCurrTm = function() {
	$.ajax({
		url:"/action/fetchRTC",
		type:"get",
		dataType:"json",
		data:"all_val=0",
		cache:false,
		success:function(data){
			$.fn.showTime(data);
		}
	});
  };
  $.fn.showTime = function(data) {
	$("#date").attr("value",data.date);
	$("#time").attr("value",data.time);
	$("#dow").attr("value",data.dow);
  };
  $.fn.getTmptID = function() {
	$.ajax({
		url:"/wapi/v1/TP/ID",
		type:"get",
		dataType:"json",
		data:"",
		cache:false,
		success:function(resp){
			$.fn.addTmptSelInit(resp);
		}
	});
  };
  $.fn.addTmptSelInit = function(resp) {
	$("#sr_id").html("");
	if (resp.response.items == 0){return;}
    $.each(resp.response.data, function(i, val){		
		$("#sr_id").append("<option value=\""+i+"\">"+val.key+"</option>");
	});
  };  
  $.fn.timeSetInit = function(resp) {
	var i, val;
	for(i=0; i<24; i++) {
		val = "";
		if (i<10) {
			val = "0";
		}
		val += i;
		$("#time_hh").append("<option value=\""+i+"\">"+val+"</option>");
		$("#ntp_sync_tm").append("<option value=\""+i+"\">"+val+"</option>");
	}	
	for(i=0; i<60; i++) {
		val = "";
		if (i<10) {
			val = "0";
		}
		val += i;
		$("#time_mm").append("<option value=\""+i+"\">"+val+"</option>");
		$("#time_ss").append("<option value=\""+i+"\">"+val+"</option>");
	}	

  };
  $.fn.getEMail = function() {
	$.ajax({
		url:"/wapi/v1/Email",
		type:"get",
		dataType:"json",
		data:"",
		cache:false,
		success:function(resp){
			$.fn.showEmailTbl(resp);
		},
		error: function (xhr, ajaxOptions, thrownError) {
						var msg = $.parseJSON(xhr.responseText);
						alert(msg.code+":"+msg.message);
		}
	});
  };
  $.fn.getMailServer = function() {
	$.ajax({
		url:"/wapi/v1/SMTP",
		type:"get",
		dataType:"json",
		data:"",
		cache:false,
		success:function(resp){
			$.fn.showMailServer(resp);
		},
		error: function (xhr, ajaxOptions, thrownError) {
						var msg = $.parseJSON(xhr.responseText);
						alert(msg.code+":"+msg.message);
		}
	});
  };
  $.fn.getDateTime = function() {
	$.ajax({
		url:"/wapi/v1/DateTime",
		type:"get",
		dataType:"json",
		data:"",
		cache:false,
		success:function(resp){
			$.fn.showDateTime(resp);
		},
		error: function (xhr, ajaxOptions, thrownError) {
						var msg = $.parseJSON(xhr.responseText);
						alert(msg.code+":"+msg.message);
		}
	});
  };
  
  $.fn.getTmptTbl = function() {
	$.ajax({
		url:"/wapi/v1/Alarm/TP",
		type:"get",
		dataType:"json",
		data:"",
		cache:false,
		success:function(resp){
			$.fn.showTmptTbl(resp);
		}
	});
  };
  $.fn.getDITbl = function() {
	$.ajax({
		url:"/wapi/v1/Alarm/DI",
		type:"get",
		dataType:"json",
		data:"",
		cache:false,
		success:function(resp){
			$.fn.showDITbl(resp);
		}
	});
  };
  $.fn.showMailServer = function(resp) {
	$("#smtp_name").val(resp.response.smtp_name);
	$("#smtp_port").val(resp.response.smtp_port);
	$("#smtp_user").val(resp.response.smtp_user);
	$("#smtp_passwd").val(resp.response.smtp_passwd);
  };

  $.fn.showDateTime = function(resp) {
	if ((resp.response.set_time == 0) || (resp.response.set_time == 1)) {
		$("#set_time")[0].selectedIndex = resp.response.set_time;
	} 
	if ((resp.response.time_zone >= 0) && (resp.response.time_zone <= 25)) {
		$("#time_zone")[0].selectedIndex = resp.response.time_zone;
	}
	$('#dpicker').datepicker("setDate", resp.response.date);
	if ((resp.response.time_hh >= 0) && (resp.response.time_hh < 24)) {
		$("#time_hh")[0].selectedIndex = resp.response.time_hh;
	}
	if ((resp.response.time_mm >= 0) && (resp.response.time_mm < 60)) {
		$("#time_mm")[0].selectedIndex = resp.response.time_mm;
	}
	if ((resp.response.time_ss >= 0) && (resp.response.time_ss < 60)) {
		$("#time_ss")[0].selectedIndex = resp.response.time_ss;
	}
	$("#ntp_server").val(resp.response.ntp_server);
	if ((resp.response.ntp_sync >= 0) && (resp.response.ntp_sync < 4)) {
		$("#ntp_sync")[0].selectedIndex = resp.response.ntp_sync;
	}
	if ((resp.response.ntp_sync_tm >= 0) && (resp.response.ntp_sync_tm < 24)) {
		$("#ntp_sync_tm")[0].selectedIndex = resp.response.ntp_sync_tm;
	}
	$("#set_time").change();
  };
  $.fn.showEmailTbl = function(resp) {
	$("#email_tbl").html("<tr><td>Address</td><td>Delete</td></tr>");
	if (resp.response.items == 0){return;}
    $.each(resp.response.data, function(i, val){
		var context_str;
		$("#email_tbl").append("<tr id=email_item_del_"+i+">");
		context_str = $.fn.addListInput("email_key_del_"+i, "mail_addr", val.key);
		$("#email_tbl tr:last-child").append("<td>"+context_str+"</td>");
		context_str = $.fn.addInputDel("email", i, val);
		$("#email_tbl tr:last-child").append("<td>"+context_str+"</td>");
		$("#email_tbl tr:last-child").append("</tr>");		
	});
  };

  $.fn.showTmptTbl = function(resp) {
	$("#tmpt_tbl").html("<tr><td>Sensor ID</td><td>Alarm Type</td><td>Threshold</td><td>DO Action</td><td>Email</td><td>Delete</td></tr>");
	if (resp.response.items == 0){return;}
    $.each(resp.response.data, function(i, val){
		var context_str;
		$("#tmpt_tbl").append("<tr id=tmpt_item_del_"+i+">");
		context_str = $.fn.addListInput("tmpt_key_del_"+i, "key", val.key);
		$("#tmpt_tbl tr:last-child").append("<td>"+context_str+"</td>");
		context_str = $.fn.addListInput("tmpt_type_del_"+i, "type", val.type);
		$("#tmpt_tbl tr:last-child").append("<td>"+context_str+"</td>");
		context_str = $.fn.addListInput("tmpt_val_del_"+i, "val", val.val);
		$("#tmpt_tbl tr:last-child").append("<td>"+context_str+"</td>");
		context_str = $.fn.addListInput("tmpt_do_del_"+i, "do", $.fn.getDOstr(val.act,val.no));
		$("#tmpt_tbl tr:last-child").append("<td>"+context_str+"</td>");
		context_str = $.fn.addListInput("tmpt_email_del_"+i, "email", val.em);
		$("#tmpt_tbl tr:last-child").append("<td>"+context_str+"</td>");

		context_str = $.fn.addInputDel("tmpt", i, val);
		$("#tmpt_tbl tr:last-child").append("<td>"+context_str+"</td>");
		$("#tmpt_tbl tr:last-child").append("</tr>");		
	});
  };
  $.fn.getDOstr = function(act, no) {
	var str;
	if(act == 0) {
		str = "No";
	} else if(act == 1) {
		str = "Low DO#"+no;
	} else if(act == 2) {
		str = "High DO#"+no;
	} 
	return str;
  };

  $.fn.addListInput = function(idname, name, val) {
	  var str="<input type=text class=\"myreadonly";
	  var val_str;
	  if (name == "key"){
		  str += " key"
	  } else if (name == "mail_addr"){
		  str += " mail_addr"
	  }
	  if (name == "type"){
		if(val == 0) {
			val_str = "Low";
		} else if(val == 1) {
			val_str = "High";
		} else if(val == 2) {
			val_str = "Change";
		} 
	  } else if (name == "email"){
		if(val == 0) {
			val_str = "No";
		} else if(val == 1) {
			val_str = "Yes";
		} 
	  } else {
		  val_str = val;
	  }
	  str += "\" id="+idname+" name="+name+" value=\""+val_str+"\" readonly>";
	  return str;
  };
  $.fn.tmptDelProc = function(btn) {
	$("#tmpt_del_tbl").html("<tr><td>Sensor ID</td><td>Alarm Type</td><td>Threshold</td><td>DO Action</td><td>Email</td></tr>");
	$("#tmpt_del_tbl").append("<tr>");
	$("#tmpt_del_tbl tr:last-child").append("<td>"+$("#tmpt_key_"+btn.name).val()+"</td>");
	$("#tmpt_del_tbl tr:last-child").append("<td>"+$("#tmpt_type_"+btn.name).val()+"</td>");
	$("#tmpt_del_tbl tr:last-child").append("<td>"+$("#tmpt_val_"+btn.name).val()+"</td>");
	$("#tmpt_del_tbl tr:last-child").append("<td>"+$("#tmpt_do_"+btn.name).val()+"</td>");
	$("#tmpt_del_tbl tr:last-child").append("<td>"+$("#tmpt_email_"+btn.name).val()+"</td>");
	$("#tmpt_del_tbl tr:last-child").append("</tr>");	
	
	$("#dlg_tmpt_del").data('name', btn.name).dialog("open");
  };
  $.fn.addInputDel = function(name, idx, val) {
	  var str="<input type=button name=del_"+idx+" id="+name+"_del_"+idx+" value=Delete onclick=$.fn."+name+"DelProc(this)>";
	  return str;
  };
  $.fn.diDelProc = function(btn) {
	$("#di_del_tbl").html("<tr><td>DI No.</td><td>Alarm Type</td><td>DO Action</td><td>Email</td></tr>");
	$("#di_del_tbl").append("<tr>");
	$("#di_del_tbl tr:last-child").append("<td>"+$("#di_key_"+btn.name).val()+"</td>");
	$("#di_del_tbl tr:last-child").append("<td>"+$("#di_type_"+btn.name).val()+"</td>");
	$("#di_del_tbl tr:last-child").append("<td>"+$("#di_do_"+btn.name).val()+"</td>");
	$("#di_del_tbl tr:last-child").append("<td>"+$("#di_email_"+btn.name).val()+"</td>");
	$("#di_del_tbl tr:last-child").append("</tr>");	
	
	$("#dlg_di_del").data('name', btn.name).dialog("open");
  };
  $.fn.emailDelProc = function(btn) {
	$("#email_del_tbl").html("<tr><td>Address</td><td>"+$("#email_key_"+btn.name).val()+"</td></tr>");
	$("#dlg_email_del").data('name', btn.name).dialog("open");
  };

  $.fn.showDITbl = function(resp) {
	$("#di_tbl").html("<tr><td>DI No.</td><td>Alarm Type</td><td>DO Action</td><td>Email</td><td>Delete</td></tr>");
	if (resp.response.items == 0){return;}
    $.each(resp.response.data, function(i, val){
		var context_str;
		$("#di_tbl").append("<tr id=di_item_del_"+i+">");
		context_str = $.fn.addListInput("di_key_del_"+i, "key", "DI#"+val.key);
		$("#di_tbl tr:last-child").append("<td>"+context_str+"</td>");
		context_str = $.fn.addListInput("di_type_del_"+i, "type", val.type);
		$("#di_tbl tr:last-child").append("<td>"+context_str+"</td>");
		context_str = $.fn.addListInput("di_do_del_"+i, "do", $.fn.getDOstr(val.act,val.no));
		$("#di_tbl tr:last-child").append("<td>"+context_str+"</td>");
		context_str = $.fn.addListInput("di_email_del_"+i, "email", val.em);
		$("#di_tbl tr:last-child").append("<td>"+context_str+"</td>");

		context_str = $.fn.addInputDel("di", i, val);
		$("#di_tbl tr:last-child").append("<td>"+context_str+"</td>");
		$("#di_tbl tr:last-child").append("</tr>");		
	});
  };
  $.fn.refresh = function(val) {
	  $('#save_btn').removeAttr('disabled');
	  window.location.reload();
  };
})(jQuery);
