(function($){
  $.fn.addMntTbl = function() {
	  $.fn.addMntTR("DI", 1, 8);
	  $.fn.addMntTR("DI", 9, 16);
	  $.fn.addCtlTR("DO", 1, 8);
	$.ajax({
		url:"/wapi/v1/TP",
		type:"get",
		dataType:"json",
		data:"",
		cache:false,
		success:function(resp){
				if (resp.response.unit == "C") {
					$("#radio_c").prop("checked", true);
					$("#radio_f").prop("checked", false);
				} else {
					$("#radio_f").prop("checked", true);
					$("#radio_c").prop("checked", false);
				}
				$("table.mntIO").updateTP(resp);
		},
		error: function (xhr, ajaxOptions, thrownError) {
			$.fn.errorhandle(xhr);
		}
	});
	$.fn.getLogList();
  };
  $.fn.showLogTbl = function(resp) {
	$("#log_tbl").html("<tr><td>ID</td><td class=\"val_width\">Value</td><td>DateTime</td></tr>");
	if (resp.response.items == 0){return;}
    $.each(resp.response.data, function(i, val){
		$("#log_tbl").append("<tr><td>"+val.key+"</td><td class=\"val_width\">"+val.val+"</td><td>"+val.date+"</td></tr>");
	});
  };
  $.fn.addMntTR = function(id, begin_idx, end_idx) {
	  var idx_str;
	  $("#"+id).append("<tr>");	  
	  for(var i=begin_idx; i<=end_idx; i++) {
		idx_str = id + i;
		$("#"+id+" tr:last-child").append("<td>"+idx_str+"</td><td><div id=\""+idx_str+"\" class=\"ball gray\"></div></td>");
	  }
	  $("#"+id+" tr:last-child").append("</tr>");
  };
  $.fn.addCtlTR = function(id, begin_idx, end_idx) {
	  var idx_str;
	  $("#"+id).append("<tr>");	  
	  for(var i=begin_idx; i<=end_idx; i++) {
		idx_str = id + i;
		$("#"+id+" tr:last-child").append("<td>"+idx_str+"</td><td><div id=\""+idx_str+"\" class=\"ball gray ctldo\"></div></td>");
	  }
	  $("#"+id+" tr:last-child").append("</tr>");
  };
  $.fn.postdata = function(val)	
  {
	$.ajax({
		url:"/wapi/v1/DO",
		type:"post",
		dataType:"json",
		data:val,
		cache:false,
		success:function(resp){
			$("table.mntIO").updateDO(resp);
		}
	});
  }
  $.fn.getLogList = function() {	
	$.ajax({
		url:"/wapi/v1/Alarm/Log",
		type:"get",
		dataType:"json",
		data:"",
		cache:false,
		success:function(resp){
			$.fn.showLogTbl(resp);
		},
		error: function (xhr, ajaxOptions, thrownError) {
			$.fn.errorhandle(xhr);
		}
	});	  
  }

  $.fn.errorhandle = function(xhr) {
	var msg = $.parseJSON(xhr.responseText);
	$("#error_resp_code").html(msg.code);
	$("#error_resp_msg").html(msg.message);
  };

  $.fn.updateDI = function(data) {
	$.each(data.response.data, function(i, val){
						$("#"+val.key).attr("class","ball "+val.val);
						}
	);
	return this;
  };
  $.fn.updateDO = function(data) {
	$.each(data.response.data, function(i, val){
						$("#"+val.key).attr("class","ball "+val.val+" ctldo");
						}
	);
	return this;
  };
  $.fn.updateTP = function(data) {
	$('#SensorMonitor').html("<table id=sensorTbl><tr><td>Sensor sum: "+data.response.items+"</td></tr><tr>");
	if (data.response.items == 0){return;}
    $.each(data.response.data, function(i, val){
		var idx = i;
		$('#SensorMonitor tr:last').append("<td>ID:"+val.key);
		$('#SensorMonitor td:last').append("<br>Temperature:<br>"+val.val+" degree "+data.response.unit);
		$('#SensorMonitor td:last').append("</td>");
	});
	$('#SensorMonitor tr:last').append("</tr></table>");
	return this;
  };
  $.fn.showDate = function(data) {
	$("#show_date").html(data.date);
  };
  $.fn.afterCtrl = function() {
	$('.ctldo').removeAttr('disabled');
  };

})(jQuery);
